// sieve.h
// by David Lambert
// 2013-04-05

#include "bitarray.h"

using namespace std;

void Sieve (BitArray& ba) {

   // first, set all bits in array
   for (int i = 0; i < ba.Length(); i++)
      ba.Set(i);

   // 0 and 1 are never prime - unset them
   ba.Unset(0);
   ba.Unset(1);

   // now complete the rest of the Sieve of Eratosthenes
   for (int i = 2; i * i < ba.Length(); i++) {
      if (ba.Query(i)) {
         for (int j = i + i; j < ba.Length(); j += i)
            ba.Unset(j);
      }
   }
} 
